/*****************************************************************************
* Copyright (c) 1990-98 Digi International Inc., All Rights Reserved
* 
* This software contains proprietary and confidential information of Digi
* International Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Digi International
* Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
* prohibited.
* 
* Restricted Rights Legend
*
* Use, duplication, or disclosure by the Government is subject to
* restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
* Technical Data and Computer Software clause at DFARS 252.227-7031 or
* subparagraphs (c)(1) and (2) of the Commercial Computer Software -
* Restricted Rights at 48 CFR 52.227-19, as applicable.
*
* Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
*
*****************************************************************************/


// PortSerial.h: interface for the CPortSerial class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PORTSERIAL_H__2EF2E632_D892_11D1_BAB9_00805F9E3135__INCLUDED_)
#define AFX_PORTSERIAL_H__2EF2E632_D892_11D1_BAB9_00805F9E3135__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Port.h"

#if defined NT5
#include "DriverServices.h"
#endif // #if defined NT5


class SERVICE_EXPORTED_CLASS CPortSerial : public CPort  
{
   DECLARE_DYNAMIC(CPortSerial)

public:
	CPortSerial(HKEY const hKeyRoot, CString const strRegPath, CConfigObject const * const pParent);
	virtual ~CPortSerial();

   virtual BOOL AddChild(void) { ASSERT(FALSE); return FALSE; }

   virtual BOOL SetParameters(void);
   virtual BOOL RemoveParameters(BOOL fRemoveKey = FALSE);

   virtual BOOL AddWizardPages(CConfigWizSheet * const pSheet);
   virtual BOOL NextWizardPage(int const nState);

   virtual CString GetInformationText(void);
   virtual BOOL DoProperties(void);

   CString GetSerialCommName(void) const { return m_strDosDevices; }

protected:
   // Access to these is necessary from our derived classes...
   CString m_strDosDevices;

   #if defined NT5
      // Allow one of our siblings to kick off the com name search
      // HDEVINFO takes a long time to generate, it's reused through this method
      void GetCommNameFromDevInfo(HDEVINFO const hInfo);
   #endif // #if defined NT5

   // Parameters gettable/settable by the config (data resides in adapter instance registry key)
   BOOL GetParameters(void);
   BOOL GetConfigData(void);
   BOOL GetHardwareId(CString& strHardwareId);
};

#endif // !defined(AFX_PORTSERIAL_H__2EF2E632_D892_11D1_BAB9_00805F9E3135__INCLUDED_)
